/* unity.vapi generated by valac 0.11.3, do not modify. */

[CCode (cprefix = "Unity", lower_case_cprefix = "unity_")]
namespace Unity {
	[CCode (cprefix = "UnityIO", lower_case_cprefix = "unity_io_")]
	namespace IO {
		[CCode (cheader_filename = "unity.h")]
		public static string[] get_system_data_dirs ();
		[CCode (cheader_filename = "unity.h")]
		public static async GLib.FileInputStream? open_from_data_dirs (string filename) throws GLib.Error;
		[CCode (cheader_filename = "unity.h")]
		public static async GLib.FileInputStream? open_from_dirs (string filename, string[] dirs) throws GLib.Error;
		[CCode (cheader_filename = "unity.h")]
		public static async void read_stream_async (GLib.InputStream input, int io_priority = GLib.Priority.LOW, GLib.Cancellable? cancellable = null, out uint8[] data, out size_t size) throws GLib.IOError;
	}
	[CCode (cprefix = "UnityPlace", lower_case_cprefix = "unity_place_")]
	namespace Place {
		[CCode (cheader_filename = "unity.h")]
		public class Browser<E> : GLib.Object {
			public Browser (string dbus_path);
			public void clear ();
			public void go_back ();
			public void go_forward ();
			public void record_state (E state, string comment);
			public string dbus_path { get; private set; }
			public signal void back (E state, string comment);
			public signal void forward (E state, string comment);
		}
		[CCode (cheader_filename = "unity.h")]
		public class Controller : GLib.Object {
			public Controller (string dbus_path);
			public void add_entry (Unity.Place.EntryInfo entry);
			public void export () throws GLib.IOError;
			public Unity.Place.EntryInfo[] get_entries ();
			public Unity.Place.EntryInfo? get_entry (string dbus_path);
			public string[] get_entry_paths ();
			public uint num_entries ();
			public void remove_entry (string dbus_path);
			public void unexport () throws GLib.IOError;
			public Unity.Place.Activation? activation { get; set; }
			public string dbus_path { get; construct; }
			public bool exported { get; }
		}
		[CCode (cheader_filename = "unity.h")]
		public class EntryInfo : GLib.Object {
			public EntryInfo (string dbus_path);
			public void clear_hint (string hint);
			public void clear_hints ();
			public string? get_hint (string hint);
			public uint num_hints ();
			public void set_hint (string hint, string val);
			public bool active { get; set; }
			public Unity.Place.Search active_global_search { get; set; }
			public Unity.Place.Search active_search { get; set; }
			public uint active_section { get; set; }
			public Unity.Place.Browser? browser { get; set; }
			public string dbus_path { get; set construct; }
			public string display_name { get; set construct; }
			public Unity.Place.RendererInfo entry_renderer_info { get; }
			public Unity.Place.RendererInfo global_renderer_info { get; }
			public string icon { get; set construct; }
			public string[] mimetypes { get; set construct; }
			public uint position { get; set construct; }
			public Dee.Model sections_model { get; set construct; }
			public bool sensitive { get; set construct; }
		}
		[CCode (cheader_filename = "unity.h")]
		public class RendererInfo : GLib.Object {
			public void clear_hint (string hint);
			public void clear_hints ();
			public string? get_hint (string hint);
			public uint num_hints ();
			public void set_hint (string hint, string val);
			public string default_renderer { get; set; }
			public Dee.Model groups_model { get; set; }
			public Dee.Model results_model { get; set; }
		}
		[CCode (cheader_filename = "unity.h")]
		public class Search : GLib.InitiallyUnowned {
			public Search (string search, GLib.HashTable<string,string> hints);
			public void clear_hint (string hint);
			public void clear_hints ();
			public bool equals (Unity.Place.Search? other);
			public string? get_hint (string hint);
			public GLib.List<weak string> get_hints ();
			public string get_search_string ();
			public uint num_hints ();
			public void set_hint (string hint, string val);
		}
		[CCode (ref_function = "unity_place_stack_ref", unref_function = "unity_place_stack_unref", cheader_filename = "unity.h")]
		public class Stack<E> {
			public Stack ();
			public void clear ();
			public bool is_empty ();
			public E peek ();
			public E pop ();
			public Unity.Place.Stack<E> push (E element);
			public int size ();
		}
		[CCode (cheader_filename = "unity.h")]
		[DBus (name = "com.canonical.Unity.Activation")]
		public interface Activation : GLib.Object {
			public abstract async uint32 activate (string uri) throws GLib.IOError;
		}
		[CCode (cprefix = "UNITY_PLACE_ACTIVATION_STATUS_", cheader_filename = "unity.h")]
		public enum ActivationStatus {
			NOT_ACTIVATED,
			ACTIVATED_SHOW_DASH,
			ACTIVATED_HIDE_DASH
		}
	}
	[CCode (cheader_filename = "unity.h")]
	public class AppInfoManager : GLib.Object {
		public void clear ();
		public Gee.List<string>? get_categories (string id);
		public static Unity.AppInfoManager get_instance ();
		public GLib.AppInfo? lookup (string id);
		public async GLib.AppInfo? lookup_async (string id) throws GLib.Error;
		public signal void changed (string id, GLib.AppInfo? new_appinfo);
	}
}
